# A unified JavaScript SDK for the Cogs (cogswell.io) APIs

[![Version npm](https://img.shields.io/npm/v/cogs-sdk.svg?style=flat-square)](http://browsenpm.org/package/cogs-sdk)

This module contains the JavaScript SDKs for the various Cogs APIs.
* Info - Informational APIs requiring no authentication.
* Tools - Customer APIs which are meant for Cogs' customers' internal use only (not end-user apps, websites, or devices). These require authentication using customer API key credentials.
* CEP - CEP APIs which are meant for client software (apps, devices, etc.). These require authentication using derived client (salt/secret pair generated by the tools API) credentials.
* Pub/Sub - Pub/Sub APIs which are also meant for client software. These require authentication using Pub/Sub project keys.

## Configuration

There are different configurations for the client and tools SDKs. While it is possible to include all key components (both the api key and client key) required in order to use both at the same time (and this is fine for testing on your own equipment), the secret component of your Cogs API key should never be placed into an app, a consumer device, or field unit.

An example of each type of config are included in this repository in the `cogs-tools.json` and `cogs-client.json` for the tools and client APIs respectively.

The tools SDK requires that the `api_key.access` and `api_key.secret` fields be populated.

The client SDK requires that the `api_key.access`, `client_key.salt`, and `client_key.secret` fields be populated.

## API Documentation

[Full Cogs API ](https://github.com/cogswell-io/node-cogs-javascript-sdk/blob/master/API.md)
