// Generated by CoffeeScript 1.12.4
(function() {
  var InfoClient, P, config, errors, logger, moment, request;

  P = require('bluebird');

  moment = require('moment');

  request = require('request');

  config = require('./config');

  errors = require('./errors');

  logger = require('./logger');

  InfoClient = (function() {
    function InfoClient(cfg1) {
      this.cfg = cfg1;
      this._initialized = true;
    }

    InfoClient.prototype.baseUrl = function() {
      var ref, ref1;
      return (ref = (ref1 = this.cfg) != null ? ref1.base_url : void 0) != null ? ref : void 0;
    };

    InfoClient.prototype.getStatus = function() {
      return this.makeRequest('GET', "/status");
    };

    InfoClient.prototype.getApiDocs = function() {
      return this.makeRequest('GET', "/api-docs");
    };

    InfoClient.prototype.getBuildInfo = function() {
      return this.makeRequest('GET', "/build_info");
    };

    InfoClient.prototype.makeRequest = function(method, path, data) {
      return new P((function(_this) {
        return function(resolve, reject) {
          var options, url;
          url = "" + (_this.baseUrl()) + path;
          options = {
            uri: url,
            method: method,
            timeout: _this.cfg.http_request_timeout
          };
          return request(options, function(error, response) {
            var json, record;
            if (error != null) {
              return reject(new errors.InfoError("Error attempting to send a request to the Cogs server", error));
            } else if (response.statusCode !== 200) {
              try {
                record = JSON.parse(json);
                json = JSON.stringify(record, null, 2);
                return reject(new errors.InfoError("Received an error response from the server", void 0, response.statusCode, json));
              } catch (error1) {
                error = error1;
                return reject(new errors.InfoError("Received an error response from the server", void 0, response.statusCode, response.body));
              }
            } else {
              try {
                return resolve(JSON.parse(response.body));
              } catch (error1) {
                error = error1;
                return reject(new errors.InfoError("Error parsing response body (expected valid JSON)", error));
              }
            }
          });
        };
      })(this));
    };

    return InfoClient;

  })();

  module.exports = {
    getClient: function(configPath) {
      return config.getConfig(configPath).then(function(cfg) {
        if (cfg.log_level != null) {
          logger.setLogLevel(cfg.log_level);
        }
        return new InfoClient(cfg);
      });
    },
    getClientWithConfig: function(cfg) {
      if (cfg.log_level != null) {
        logger.setLogLevel(cfg.log_level);
      }
      return P.resolve(new InfoClient(cfg));
    }
  };

}).call(this);
