// Generated by CoffeeScript 1.12.4
(function() {
  var _, log, logger, moment, setupLogger, winston,
    slice = [].slice;

  _ = require('lodash');

  moment = require('moment');

  winston = require('winston');

  winston.exitOnError = false;

  logger = void 0;

  setupLogger = function(level) {
    var consoleConfig;
    if (level == null) {
      level = 'error';
    }
    if (level === 'off') {
      return logger = void 0;
    } else {
      consoleConfig = {
        level: level,
        timestamp: function() {
          return moment.utc().toISOString();
        }
      };
      return logger = new winston.Logger({
        exitOnError: false,
        transports: [new winston.transports.Console(consoleConfig)]
      });
    }
  };

  log = function() {
    var args, level, text;
    level = arguments[0], text = arguments[1], args = 3 <= arguments.length ? slice.call(arguments, 2) : [];
    if (logger != null) {
      if (_.isString(text)) {
        return logger.log.apply(logger, [level, "[cogs-sdk]: " + text].concat(slice.call(args)));
      } else {
        return logger.log.apply(logger, [level, "[cogs-sdk]: ", text].concat(slice.call(args)));
      }
    }
  };

  setupLogger();

  module.exports = {
    setLogLevel: function(level) {
      return setupLogger(level);
    },
    setErrorLevel: function() {
      return setupLogger('error');
    },
    setWarnLevel: function() {
      return setupLogger('warn');
    },
    setInfoLevel: function() {
      return setupLogger('info');
    },
    setVerboseLevel: function() {
      return setupLogger('verbose');
    },
    setDebugLevel: function() {
      return setupLogger('debug');
    },
    turnLoggerOff: function() {
      return setupLogger('off');
    },
    log: function() {
      var args;
      args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
      return log.apply(null, args);
    },
    error: function() {
      var args;
      args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
      return log.apply(null, ['error'].concat(slice.call(args)));
    },
    warn: function() {
      var args;
      args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
      return log.apply(null, ['warn'].concat(slice.call(args)));
    },
    info: function() {
      var args;
      args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
      return log.apply(null, ['info'].concat(slice.call(args)));
    },
    verbose: function() {
      var args;
      args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
      return log.apply(null, ['verbose'].concat(slice.call(args)));
    },
    debug: function() {
      var args;
      args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
      return log.apply(null, ['debug'].concat(slice.call(args)));
    }
  };

}).call(this);
