// Generated by CoffeeScript 1.12.4
(function() {
  var EventEmitter, Joi, LRU, P, PubSubWebSocket, WebSocket, _, auth, defaultReconnectDelay, dialect, errors, isNode, jsonify, logger, maxReconnectDelay, moment, request,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  _ = require('lodash');

  P = require('bluebird');

  Joi = require('joi');

  LRU = require('lru-cache');

  moment = require('moment');

  dialect = require('cogs-pubsub-dialect');

  request = require('request');

  EventEmitter = require('eventemitter3');

  auth = require('./auth');

  errors = require('./errors');

  logger = require('./logger');

  WebSocket = require('./ws')();

  jsonify = function(obj) {
    return JSON.stringify(obj, null, 2);
  };

  isNode = function() {
    return window === void 0;
  };

  defaultReconnectDelay = 5000;

  maxReconnectDelay = 120000;

  PubSubWebSocket = (function(superClass) {
    extend(PubSubWebSocket, superClass);

    function PubSubWebSocket(keys1, options1) {
      var ref, ref1, ref10, ref2, ref3, ref4, ref5, ref6, ref7, ref8, ref9;
      this.keys = keys1;
      this.options = options1;
      PubSubWebSocket.__super__.constructor.call(this);
      this.autoReconnectDelay = defaultReconnectDelay;
      this.sessionUuid = (ref = this.options) != null ? ref.sessionUuid : void 0;
      this.url = (ref1 = (ref2 = this.options) != null ? ref2.url : void 0) != null ? ref1 : 'wss://api.cogswell.io/pubsub';
      this.connectTimeout = (ref3 = (ref4 = this.options) != null ? ref4.connectTimeout : void 0) != null ? ref3 : 5000;
      this.autoReconnect = (ref5 = (ref6 = this.options) != null ? ref6.autoReconnect : void 0) != null ? ref5 : true;
      this.pingInterval = (ref7 = (ref8 = this.options) != null ? ref8.pingInterval : void 0) != null ? ref7 : 15000;
      this.logLevel = (ref9 = (ref10 = this.options) != null ? ref10.logLevel : void 0) != null ? ref9 : 'error';
      this.hasConnected = false;
      logger.setLogLevel(this.logLevel);
      logger.info("Set logger level to '" + this.logLevel + "'");
      if (this.options != null) {
        logger.info("Options based to new Pub/Sub WebSocket:\n " + (JSON.stringify(this.options, null, 2)));
      }
      this.handlers = {};
      this.sock = null;
      this.pingerRef = null;
      this.recordCount = 0;
      this.sequence = 0;
      this.outstanding = LRU({
        max: 10000,
        maxAge: 60 * 1000,
        dispose: function(sequence, promise) {
          if ((promise != null ? promise.completed : void 0) !== true) {
            logger.info("Discarded old sequence " + sequence);
            return promise != null ? typeof promise.reject === "function" ? promise.reject(new errors.PubSubResponseTimeout("Timeout awaiting response to sequence " + sequence, null, sequence)) : void 0 : void 0;
          }
        }
      });
    }

    PubSubWebSocket.prototype.getSessionUuid = function() {
      return new P((function(_this) {
        return function(resolve, reject) {
          var message, record, seq;
          if (_this.sock != null) {
            seq = _this.sequence += 1;
            record = {
              seq: seq,
              action: 'session-uuid'
            };
            return _this.sock.send(JSON.stringify(record)).then(function() {
              return _this.outstanding.set(seq, {
                resolve: resolve,
                reject: reject
              });
            })["catch"](function(error) {
              var message;
              message = "Socket error while requesting client UUID:";
              logger.error(message, error);
              return reject(new errors.PubSubError(message, error));
            });
          } else {
            message = "Could not fetch the client UUID as the socket is currently disconnected.";
            logger.warn(message);
            return reject(new errors.PubSubError(message, null));
          }
        };
      })(this)).then(function(response) {
        return response.uuid;
      });
    };

    PubSubWebSocket.prototype.publishWithAck = function(channel, message) {
      return new P((function(_this) {
        return function(resolve, reject) {
          return _this.publish(channel, message, void 0, true).then(function(seq) {
            return _this.outstanding.set(seq, {
              resolve: resolve,
              reject: reject
            });
          })["catch"](function(error) {
            return reject(error);
          });
        };
      })(this));
    };

    PubSubWebSocket.prototype.publish = function(channel, message, errorHandler, ack) {
      return new P((function(_this) {
        return function(resolve, reject) {
          var record, seq;
          if (_this.sock != null) {
            if (ack !== true) {
              ack = void 0;
            }
            seq = _this.sequence += 1;
            record = {
              seq: seq,
              action: 'pub',
              chan: channel,
              msg: message,
              ack: ack
            };
            return _this.sock.send(JSON.stringify(record)).then(function() {
              resolve(seq);
              if (errorHandler != null) {
                return _this.outstanding.set(seq, {
                  reject: function(error) {
                    if (error instanceof errors.PubSubResponseTimeout) {
                      return logger.verbose("Timeout of error handler for sequence " + seq + " (Success).");
                    } else {
                      logger.warn("Calling user-supplied error handler for sequence " + seq);
                      return errorHandler(error);
                    }
                  },
                  resolve: function(response) {
                    return logger.verbose("Ack for seq " + seq + " which has no ack handling.");
                  }
                });
              }
            })["catch"](function(error) {
              message = "Socket error while publishing message:";
              logger.error(message, error);
              return reject(new errors.PubSubError(message, error));
            });
          } else {
            message = "Could not publish a message as the socket is disconnected.";
            logger.warn(message);
            return reject(new errors.PubSubError(message, null));
          }
        };
      })(this));
    };

    PubSubWebSocket.prototype.subscribe = function(channel, handler) {
      if (typeof handler === 'function') {
        this.handlers[channel] = handler;
      }
      return new P((function(_this) {
        return function(resolve, reject) {
          var message, record, seq;
          if (_this.sock != null) {
            seq = _this.sequence += 1;
            record = {
              seq: seq,
              action: 'subscribe',
              channel: channel
            };
            return _this.sock.send(JSON.stringify(record)).then(function() {
              return _this.outstanding.set(seq, {
                resolve: resolve,
                reject: reject
              });
            })["catch"](function(error) {
              var message;
              message = "Socket error while subscribing to channel:";
              logger.error(message, error);
              return reject(new errors.PubSubError(message, error));
            });
          } else {
            message = "Could not subscribe to channel as the socket is currently disconnected.";
            logger.warn(message);
            return reject(new errors.PubSubError(message, null));
          }
        };
      })(this)).then(function(response) {
        return response.channels;
      })["catch"]((function(_this) {
        return function(error) {
          logger.error("Error subscribing to channel '" + channel + "'", error);
          delete _this.handlers[channel];
          throw error;
        };
      })(this));
    };

    PubSubWebSocket.prototype.unsubscribe = function(channel) {
      delete this.handlers[channel];
      return new P((function(_this) {
        return function(resolve, reject) {
          var message, record, seq;
          if (_this.sock != null) {
            seq = _this.sequence += 1;
            record = {
              seq: seq,
              action: 'unsubscribe',
              channel: channel
            };
            return _this.sock.send(JSON.stringify(record)).then(function() {
              return _this.outstanding.set(seq, {
                resolve: resolve,
                reject: reject
              });
            })["catch"](function(error) {
              var message;
              message = "Socket error while unsubscribing from channel:";
              logger.error(message, error);
              return reject(new errors.PubSubError(message, error));
            });
          } else {
            message = "Could not unsubscribe from channel as the socket is currently disconnected.";
            logger.warn(message);
            return reject(new errors.PubSubError(message, null));
          }
        };
      })(this)).then(function(response) {
        return response.channels;
      });
    };

    PubSubWebSocket.prototype.unsubscribeAll = function() {
      this.handlers = {};
      return new P((function(_this) {
        return function(resolve, reject) {
          var message, record, seq;
          if (_this.sock != null) {
            seq = _this.sequence += 1;
            record = {
              seq: seq,
              action: 'unsubscribe-all'
            };
            return _this.sock.send(JSON.stringify(record)).then(function() {
              return _this.outstanding.set(seq, {
                resolve: resolve,
                reject: reject
              });
            })["catch"](function(error) {
              var message;
              message = "Socket error while unsubscribing from channel:";
              logger.error(message, error);
              return reject(new errors.PubSubError(message, error));
            });
          } else {
            message = "Could not unsubscribe from channel as the socket is currently disconnected.";
            logger.warn(message);
            return reject(new errors.PubSubError(message, null));
          }
        };
      })(this)).then(function(response) {
        return response.channels;
      });
    };

    PubSubWebSocket.prototype.listSubscriptions = function() {
      return new P((function(_this) {
        return function(resolve, reject) {
          var message, record, seq;
          if (_this.sock != null) {
            seq = _this.sequence += 1;
            record = {
              seq: seq,
              action: 'subscriptions'
            };
            return _this.sock.send(JSON.stringify(record)).then(function() {
              return _this.outstanding.set(seq, {
                resolve: resolve,
                reject: reject
              });
            })["catch"](function(error) {
              var message;
              message = "Socket error listing connection subscriptions:";
              logger.error(message, error);
              return reject(new errors.PubSubError(message, error));
            });
          } else {
            message = "Could not list channel subscriptions as the socket is currently disconnected.";
            logger.warn(message);
            return reject(new errors.PubSubError(message, null));
          }
        };
      })(this)).then(function(response) {
        return response.channels;
      });
    };

    PubSubWebSocket.prototype.clearPinger = function() {
      var error;
      if (this.pingerRef != null) {
        try {
          return clearInterval(this.pingerRef);
        } catch (error1) {
          error = error1;
          return logger.error("Error clearing ping interval:", error);
        } finally {
          this.pingerRef = null;
        }
      }
    };

    PubSubWebSocket.prototype.dropConnection = function(options) {
      var error;
      if (options == null) {
        options = void 0;
      }
      if (_.isNumber(options != null ? options.autoReconnectDelay : void 0)) {
        this.autoReconnectDelay = options.autoReconnectDelay;
      }
      this.clearPinger();
      if (this.sock != null) {
        try {
          return this.sock.close();
        } catch (error1) {
          error = error1;
          logger.error("Error while closing WebSocket:", error);
          throw error;
        } finally {
          this.sock = null;
        }
      }
    };

    PubSubWebSocket.prototype.close = function() {
      return new P((function(_this) {
        return function(resolve, reject) {
          var error;
          _this.autoReconnect = false;
          try {
            return resolve(_this.dropConnection());
          } catch (error1) {
            error = error1;
            return reject(error);
          }
        };
      })(this));
    };

    PubSubWebSocket.prototype.disconnect = function() {
      return this.close();
    };

    PubSubWebSocket.prototype.connect = function() {
      var connectHandler;
      connectHandler = (function(_this) {
        return function(resolve, reject) {
          var data, error, headers, timeout;
          if (_this.sock != null) {
            return resolve();
          } else {
            data = auth.socketAuth(_this.keys, _this.sessionUuid);
            _this.permissions = data.permissions;
            if (data != null) {
              logger.info("Finished assembling auth data:\n " + (JSON.stringify(data, null, 2)));
            }
            headers = {
              'Payload': data.bufferB64,
              'PayloadHMAC': data.hmac
            };
            timeout = _this.connectTimeout;
            try {
              _this.sock = new WebSocket(_this.url, headers, timeout);
              _this.sock.once('close', function(code, cause) {
                var error, message, minimumDelay, nextDelay, previousDelay, reconnect;
                if (_this.autoReconnect === true) {
                  _this.sock = null;
                  if (_this.pingerRef != null) {
                    try {
                      clearInterval(_this.pingerRef);
                    } catch (error1) {
                      error = error1;
                      logger.error("Error clearing pinger interval:", error);
                    } finally {
                      _this.pingerRef = null;
                    }
                  }
                  reconnect = function() {
                    return _this.connect().then(function() {
                      setImmediate(function() {
                        return _this.emit('reconnect');
                      });
                      return logger.info("Pub/Sub WebSocket replaced.");
                    })["catch"](function(error) {
                      setImmediate(function() {
                        return _this.emit('error', error);
                      });
                      return logger.error("Error replacing Pub/Sub WebSocket", error);
                    });
                  };
                  logger.info("Connection closed. Reconnecting in 5 seconds.");
                  setTimeout(reconnect, _this.autoReconnectDelay);
                  previousDelay = _this.autoReconnectDelay;
                  minimumDelay = Math.max(defaultReconnectDelay, previousDelay);
                  nextDelay = Math.min(minimumDelay, maxReconnectDelay) * 2;
                  return _this.autoReconnectDelay = nextDelay;
                } else {
                  setImmediate(function() {
                    return _this.emit('close');
                  });
                  if (_this.hasConnected) {
                    return logger.info("Pub/Sub WebSocket closed.");
                  } else {
                    message = "Websocket closed before the connection was established";
                    logger.info(message);
                    return reject(new Error(message));
                  }
                }
              });
              _this.sock.once('open', function() {
                var pinger;
                logger.info("Pub/Sub WebSocket opened.");
                _this.hasConnected = true;
                _this.autoReconnectDelay = defaultReconnectDelay;
                setImmediate(function() {
                  return _this.emit('open');
                });
                pinger = function() {
                  logger.verbose("Sending PING to keep the Pub/Sub WebSocket alive.");
                  if (_this.sock != null) {
                    return _this.sock.ping();
                  }
                };
                _this.pingerRef = setInterval(pinger, _this.pingInterval);
                if (_this.autoReconnect === true) {
                  _this.getSessionUuid().then(function(uuid) {
                    if (_this.sessionUuid !== uuid) {
                      setImmediate(function() {
                        return _this.emit('new-session', uuid);
                      });
                    }
                    return _this.sessionUuid = uuid;
                  })["catch"](function(error) {
                    setImmediate(function() {
                      return _this.emit('error', error);
                    });
                    return logger.error("Error fetching session UUID:", error);
                  });
                }
                return resolve();
              });
              _this.sock.on('error', function(error) {
                setImmediate(function() {
                  return _this.emit('error', error);
                });
                if (!_this.hasConnected) {
                  logger.error("WebSocket connect error:", error);
                  return reject(error);
                } else {
                  return logger.error("WebSocket error:", error);
                }
              });
              _this.sock.on('message', function(rec) {
                var action, base, chan, error, id, message, msg, promise, record, time, validation;
                logger.verbose("Received a record:", rec);
                _this.recordCount += 1;
                setImmediate(function() {
                  return _this.emit('raw-record', rec);
                });
                validation = dialect.parseAndAutoValidate(rec);
                if (!validation.isValid) {
                  error = validation.error;
                  message = 'Unknown action or bad record format from server';
                  setImmediate(function() {
                    return _this.emit('error', new errors.PubSubError(message + ": " + rec, error));
                  });
                  return logger.error(message + ": " + rec + ": " + error + "\n" + error.stack);
                } else {
                  record = validation.value;
                  if (record.seq != null) {
                    promise = _this.outstanding.get(record.seq);
                    if (promise == null) {
                      message = 'Received a record containing an unknown sequence number.';
                      record.sequence = record.seq;
                      delete record.seq;
                      setImmediate(function() {
                        return _this.emit('error-response', record);
                      });
                      return logger.error(message + ": " + rec);
                    } else {
                      promise.completed = true;
                      _this.outstanding.del(record.seq);
                      resolve = promise.resolve, reject = promise.reject;
                      if (record.code === 200) {
                        if (record.action === 'pub' && (record.id != null)) {
                          return typeof resolve === "function" ? resolve(record.id) : void 0;
                        } else {
                          return typeof resolve === "function" ? resolve(record) : void 0;
                        }
                      } else {
                        record.sequence = record.seq;
                        delete record.seq;
                        setImmediate(function() {
                          return _this.emit('error-response', record);
                        });
                        return typeof reject === "function" ? reject(new errors.PubSubFailureResponse(record.message, null, record.code, record.details, record)) : void 0;
                      }
                    }
                  } else if (record.action === 'msg') {
                    id = record.id, action = record.action, time = record.time, chan = record.chan, msg = record.msg;
                    if (typeof (base = _this.handlers)[chan] === "function") {
                      base[chan]({
                        channel: chan,
                        message: msg,
                        timestamp: time,
                        id: id
                      });
                    }
                    return setImmediate(function() {
                      return _this.emit('message', {
                        channel: chan,
                        message: msg,
                        timestamp: time,
                        id: id
                      });
                    });
                  } else if (record.action === 'invalid-request') {
                    setImmediate(function() {
                      return _this.emit('error-response', record);
                    });
                    return logger.error("Server received a request which did not contain a sequence number:", record);
                  } else {
                    record.details = 'Valid, but un-handled response type.';
                    record.sequence = record.seq;
                    delete record.seq;
                    setImmediate(function() {
                      return _this.emit('error-response', record);
                    });
                    return logger.error("" + message);
                  }
                }
              });
              return _this.sock.once('connectFailed', function(error) {
                setImmediate(function() {
                  return _this.emit('connectFailed', error);
                });
                logger.error("Failed to connect to Pub/Sub WebSocket");
                return reject(new errors.ApiError("Server rejected the pub/sub WebSocket", error));
              });
            } catch (error1) {
              error = error1;
              logger.error("Error creating WebSocket for namespace '" + _this.namespace + "' channel " + (jsonify(_this.attributes)));
              return reject(new errors.ApiError("Error creating the pub/sub WebSocket", error));
            }
          }
        };
      })(this);
      return new P(connectHandler);
    };

    return PubSubWebSocket;

  })(EventEmitter);

  module.exports = {
    connect: function(keys, options) {
      var ws;
      ws = new PubSubWebSocket(keys, options);
      return ws.connect().then(function() {
        return ws;
      });
    }
  };

}).call(this);
