// Generated by CoffeeScript 1.12.4
(function() {
  var BaseWS, BrowserWS, EventEmitter, NodeWS, P, browserWs, isNode, nodeWs, ref,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  P = require('bluebird');

  EventEmitter = require('eventemitter3');

  ref = require('websocket'), nodeWs = ref.client, browserWs = ref.w3cwebsocket;

  BaseWS = (function(superClass) {
    extend(BaseWS, superClass);

    function BaseWS(url1, headers1, timeout) {
      this.url = url1;
      this.headers = headers1;
      BaseWS.__super__.constructor.call(this);
      this.config = {
        closeTimeout: timeout,
        keepaliveInterval: 15000
      };
    }

    return BaseWS;

  })(EventEmitter);

  NodeWS = (function(superClass) {
    extend(NodeWS, superClass);

    function NodeWS(url, headers, timeout) {
      NodeWS.__super__.constructor.call(this, url, headers, timeout);
      this.socket = new nodeWs(this.config);
      this.connection = null;
      this.socket.on('connectFailed', (function(_this) {
        return function(error) {
          return setTimeout(function() {
            return _this.emit('connectFailed', error);
          });
        };
      })(this));
      this.socket.on('connect', (function(_this) {
        return function(connection) {
          _this.connection = connection;
          connection.on('error', function(error) {
            return setTimeout(function() {
              return _this.emit('error', error);
            });
          });
          connection.on('message', function(message) {
            var error;
            try {
              return setTimeout(function() {
                return _this.emit('message', message.utf8Data);
              });
            } catch (error1) {
              error = error1;
              return setTimeout(function() {
                return _this.emit('error', error);
              });
            }
          });
          connection.on('close', function() {
            return setTimeout(function() {
              return _this.emit('close');
            });
          });
          return setTimeout(function() {
            return _this.emit('open');
          });
        };
      })(this));
      this.socket.connect(url, void 0, void 0, headers);
    }

    NodeWS.prototype.close = function() {
      return new P((function(_this) {
        return function(resolve, reject) {
          if (_this.connection != null) {
            _this.connection.once('error', function(error) {
              return reject(error);
            });
            _this.connection.once('close', function() {
              return resolve();
            });
            _this.connection.close();
            _this.connection = null;
            return _this.socket = null;
          } else {
            return resolve();
          }
        };
      })(this));
    };

    NodeWS.prototype.ping = function() {
      if (this.connection != null) {
        return this.connection.ping();
      }
    };

    NodeWS.prototype.send = function(data) {
      return new P((function(_this) {
        return function(resolve, reject) {
          if (_this.connection != null) {
            return _this.connection.send(data, function(error) {
              if (error != null) {
                return reject(error);
              } else {
                return resolve();
              }
            });
          } else {
            return reject(new Error("Not connected."));
          }
        };
      })(this));
    };

    return NodeWS;

  })(BaseWS);

  BrowserWS = (function(superClass) {
    extend(BrowserWS, superClass);

    function BrowserWS(url, headers, timeout) {
      BrowserWS.__super__.constructor.call(this, url, headers, timeout);
      this.connected = false;
      this.socket = new browserWs(url, void 0, void 0, headers, this.config);
      this.socket.onopen((function(_this) {
        return function() {
          _this.connected = true;
          return setImmediate(function() {
            return _this.emit('open');
          });
        };
      })(this));
      this.socket.onmessage((function(_this) {
        return function(message) {
          return setImmediate(function() {
            return _this.emit('message', message);
          });
        };
      })(this));
      this.socket.onclose((function(_this) {
        return function() {
          return setImmediate(function() {
            return _this.emit('close');
          });
        };
      })(this));
      this.socket.onerror((function(_this) {
        return function(error) {
          if (_this.connected) {
            return setImmediate(function() {
              return _this.emit('error', error);
            });
          } else {
            return setImmediate(function() {
              return _this.emit('connectFailed', error);
            });
          }
        };
      })(this));
    }

    BrowserWS.prototype.close = function() {
      return new P((function(_this) {
        return function(resolve, reject) {
          if (_this.socket != null) {
            _this.socket.onerror(function(error) {
              return reject(error);
            });
            _this.socket.onclose(function() {
              return resolve();
            });
            _this.socket.close();
            return _this.socket = null;
          } else {
            return resolve();
          }
        };
      })(this));
    };

    BrowserWS.prototype.ping = function() {
      if (this.socket != null) {
        return this.socket.ping();
      }
    };

    BrowserWS.prototype.send = function(data) {
      return new P((function(_this) {
        return function(resolve, reject) {
          if (_this.socket != null) {
            return _this.socket.send(data, function(error) {
              if (error != null) {
                return reject(error);
              } else {
                return resolve();
              }
            });
          } else {
            return reject(new Error("Not connected."));
          }
        };
      })(this));
    };

    return BrowserWS;

  })(BaseWS);

  isNode = new Function("try {return this===global;}catch(e){return false;}");

  module.exports = function() {
    if (isNode()) {
      return NodeWS;
    } else {
      return BrowserWS;
    }
  };

}).call(this);
